%define version_major 2
%define version_minor 7
%define version_micro 0
%define version_full %{version_major}.%{version_minor}.%{version_micro}
%define version_brief %{version_major}.%{version_minor}
%define version_src %{version_major}_%{version_minor}_%{version_micro}

%define lib_name %{?mklibname:%mklibname %{name} %{version_major}}%{!?mklibname:lib%{name}%{version_major}}

Summary: CORBA Event Service for omniORB
Name:    omniEvents
Version: %{version_full}
Release: 2%{?dist}
License: LGPL
Group:   System/Libraries
Source0: %{name}-%{version_src}-src.tar.gz
Patch0:  %{name}-%{version_src}-limits.patch.bz2
Patch1:  %{name}-%{version_src}-stdio.patch.bz2
URL:     http://www.omnievents.org/
BuildRequires:  gcc-c++
BuildRequires:  python
BuildRequires:  libomniorb-devel glibc-devel
BuildRequires:  pkgconfig
%if "%{_vendor}" == "suse"
BuildRequires:  sysconfig klogd rsyslog
%endif
Buildroot:      %{_tmppath}/%{name}-%{version}-root

%description
%{name} enables CORBA applications to communicate through asynchronous
broadcast channels rather than direct method calls.
It is a small, efficient implementation of the Object Management Group's
Event Service specification designed to work with omniORB.

%package -n %{lib_name}
Summary: CORBA Event Service for omniORB
Group:   System/Libraries
Requires(post): /sbin/ldconfig
Requires(postun): /sbin/ldconfig
Provides:       lib%{name} = %{version}-%{release} %{name} = %{version}-%{release}
Provides:       libomnievents = %{version}-%{release}

%description -n %{lib_name}
%{name} enables CORBA applications to communicate through asynchronous
broadcast channels rather than direct method calls.
It is a small, efficient implementation of the Object Management Group's
Event Service specification designed to work with omniORB.

%package server
Summary:   CORBA Event Service daemon
Group:     Development/C++
Requires:  %{lib_name} = %{version}-%{release}
Provides:  omnievents-server = %{version}-%{release}

%description server
The CORBA Event Service daemon as a standalone executable.

%package bootscripts
Summary: Utility programs
Group: Development/C++
%if "%{_vendor}" == "suse"
Requires(post): /sbin/insserv
Requires(preun): /sbin/insserv
%else
Requires(pre):  /sbin/service
Requires(post): /sbin/service /sbin/chkconfig
Requires(preun): /sbin/service /sbin/chkconfig
%endif
Requires: %{name}-server = %{version}-%{release} %{name}-utils = %{version}-%{release}
Requires(pre):  syslog
Provides: omnievents-bootscripts = %{version}-%{release}

%description bootscripts
Automatic starting of the %{name} CORBA Event Service.

%package utils
Summary:   Utility programs
Group:     Development/C++
Requires:  %{lib_name} = %{version}-%{release}
Provides:  omnievents-utils = %{version}-%{release}

%description utils
%{name} utility programs which may be useful at runtime.

%package devel
Summary: Header files and libraries needed for %{name} development
Group:          Development/C++
Requires:       %{lib_name} = %{version}-%{release}
Provides:  libomnievents-devel = %{version}-%{release} omnievents-devel = %{version}-%{release}
Conflicts: %{name}-devel < %{version}-%{release}
Obsoletes: libomniEvents-devel

%description devel
The header files and libraries needed for developing programs using %{name}.

%package doc
Summary: Documentation and examples for %{name}
Group:          Development/C++
Provides:  libomnievents-doc = %{version}-%{release} omnievents-doc = %{version}-%{release}
Obsoletes: libomniEvents-doc

%description doc
Developer documentation and examples.

%prep
%setup -n %{name} %-%{version_src}
%patch0 -p1
%patch1 -p1

%{?configure:%configure}%{!?configure:CPPFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{_prefix} --libdir=%{_libdir}} --enable-unloadable-stubs

%build
%{?make:%make}%{!?make:make IMPORT_CPPFLAGS+="$RPM_OPT_FLAGS"} all
%{?make:%make}%{!?make:make IMPORT_CPPFLAGS+="$RPM_OPT_FLAGS"} -C src oelite

%install
[ -z %{buildroot} ] || rm -rf %{buildroot}
mkdir %{buildroot}

install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/default
install -d %{buildroot}%{_mandir}/{man1,man8}
install -d -m 700 %{buildroot}%{_localstatedir}/lib/omniEvents

%if "%{_vendor}" == "suse"
%{?makeinstall:%makeinstall}%{!?makeinstall:make DESTDIR=%{buildroot} install}
%else
%{?make:%make}%{!?make:make} install DESTDIR=%{buildroot}
%endif

install -m 755 src/oelite %{buildroot}%{_sbindir}/omniEvents
install -m 775 etc/init.d/omniorb-eventservice %{buildroot}%{_initrddir}/omniEvents
install -m 644 etc/default/omniorb-eventservice %{buildroot}%{_sysconfdir}/default
#install -m 644 doc/man/*.1 %{buildroot}%{_mandir}/man1
#install -m 644 doc/man/omniEvents.8 %{buildroot}%{_mandir}/man8

# deprecated, but still installed by make install in 2.7.0
rm -f %{buildroot}%{_includedir}/*.{h,hh}

%if "%{_vendor}" == "suse"
  # Most SUSE service scripts have a corresponding link into /usr/sbin
  ln -sf %{_initrddir}/omniEvents %{buildroot}%{_sbindir}/rcomniEvents
%endif

%clean
[ -z %{buildroot} ] || rm -rf %{buildroot}

%post -n %{lib_name}
/sbin/ldconfig

%pre bootscripts
# A previous version is already installed?
if [ $1 -ge 2 ]; then
%if "%{_vendor}" == "suse"
  %{_sbindir}/rcomniEvents stop >/dev/null 2>&1
%else
  /sbin/service omniEvents stop >/dev/null 2>&1
%endif
fi

%post bootscripts
%if "%{_vendor}" == "suse"
/sbin/insserv omniEvents
%{_sbindir}/rcomniEvents restart >/dev/null 2>&1
%else
/sbin/chkconfig --add omniEvents
/sbin/service omniEvents restart >/dev/null 2>&1
%endif

%preun bootscripts
# Are we removing the package completely?
if [ $1 -eq 0 ]; then
%if "%{_vendor}" == "suse"
  %{_sbindir}/rcomniEvents stop >/dev/null 2>&1
  /sbin/insserv -r omniEvents
%else
  /sbin/service omniEvents stop >/dev/null 2>&1
  /sbin/chkconfig --del omniEvents
%endif
fi

%postun -n %{lib_name}
/sbin/ldconfig

# main package includes libraries and copyright info
%files -n %{lib_name}
%defattr (-,root,root)
%doc LICENSE
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/default/*
%{_libdir}/*.so.*
%dir %{_datadir}/idl/omniEvents
%{_datadir}/idl/omniEvents/*

%files server
%defattr (-,root,root)
%dir %attr(700,omni,omni) %{_localstatedir}/lib/omniEvents
%attr(755,root,root) %{_sbindir}/omniEvents
#%attr(644,root,man) %{_mandir}/man8/*

%files bootscripts
%defattr (-,root,root)
%config(noreplace) %attr(775,root,root) %{_initrddir}/*
%if "%{_vendor}" == "suse"
%{_sbindir}/rcomniEvents
%endif

%files utils
%defattr (-,root,root)
%attr(755,root,root) %{_bindir}/*
#%attr(644,root,man) %{_mandir}/man1/*

%files devel
%defattr(-,root,root)
%doc CHANGES* README
%{_libdir}/*.a
%{_libdir}/*.so
%{_libdir}/pkgconfig/*
%{_includedir}/omniEvents

%files doc
%defattr(-,root,root)
%doc doc/omnievents* #doc/*.html doc/doxygen

%changelog
* Wed Nov 24 2010 Dirk O. Kaar <dok@dok-net.net> 2.7.0-2
- Merge in improvements for current omniORB spec files from Thomas Lockhart

* Wed Apr 27 2005 Dirk Siebnich <dok@dok-net.net>  2.6.2-1
- better support for x86_64

* Mon Nov 15 2004 Dirk Siebnich <dok@dok-net.net>  2.6.1-1
- packaged for RPM
